(in-package  :custom)
(use-package :oli)
;; 
; = ; = ; =?? ; = ; = ; = ; =; =
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(sd-defdialog 'geo_anordnen
  :dialog-title "Geo. anordnen"
  :toolbox-button t ; damit erscheint das Makro nicht in der toolbox (sonst "t")
  :PRECONDITION '(if (sd-inq-curr-wp)
				:OK
				(values :error (format nil "Sie haben keine aktive Arbeitsebene auf der der Text erstellt werden koennte!~aBitte erstellen Sie zuerst eine Arbeitsebene." '#\newline))
				)
  :variables
  '(
	(Bild			:value-type		:image			;128x128px und wenig Farbe
					:image-file		"Geo_anordnen_300h.bmp"
	)
	(Pkt1			:value-type     :point-2d
					:title 			"Punkt 1"
					:prompt-text	"Bitte den ersten Punkt angeben")	     ;Text in der Aufforderungsleiste
    (Pkt2           :value-type	    :point-2d
                    :title          "Punkt 2"
					:after-input (berechnen)
					:prompt-text	"Bitte den zweiten Punkt angeben")	     ;Text in der Aufforderungsleiste
	(rand  		    :value-type		:length			                         ;legt den Typ des Eingabefeldes fest
					:title			"Rand"	 	                             ;Titel des Eingabefeldbuttons 
					:initial-value	15				                         ;vordefinierter Wert
					:after-input (berechnen)
					:prompt-text	"Bitte den Rand angeben (>=0)")	         ;Text in der Aufforderungsleiste
	(geo-mass	    :value-type		:length               		             ;legt den Typ des Eingabefeldes fest
					:title			"Geo-mazs"	                             ;Titel des Eingabefeldbuttons 
					:initial-value	10		                                 ;vordefinierter Wert
					:after-input (berechnen)		                         
					:prompt-text	"Bitte das Geometriemasz angeben (>=0)")  ;Text in der Aufforderungsleiste
	(anzahl   	    :value-type		:positive-number                         ;legt den Typ des Eingabefeldes fest
					:title			"Anzahl"	 	                         ;Titel des Eingabefeldbuttons 
					:initial-value	4			
					:after-input (berechnen)	                         ;vordefinierter Wert
					:prompt-text	"Bitte die Geometrieanzahl (Teilung) angeben (>=0)")  ;Text in der Aufforderungsleiste
	
	("------------")
    (zw-raum
                    :value-type	   :display-only
	                :display-units :length
                    :title "Zw-raum")
	)

  :local-functions
  '(
	(Split()
 	(setf u1 (gpnt2d_x Pkt1));; U-Koordinaten selectieren 
 	(setf v1 (gpnt2d_y Pkt1));; V-Koordinaten selectieren 
	(setf u2 (gpnt2d_x Pkt2));; U-Koordinaten selectieren 
 	(setf v2 (gpnt2d_y Pkt2));; V-Koordinaten selectieren 
	(let ((counter 1))
		(loop
			;(display counter)
			(C_LINE_INF :BISECT (/ counter teile) Pkt1 Pkt2)
			(incf counter);; counter + 1
			(when (= counter teile)
				(return "done")
			); end when
		);end loop
	); end let
	); end Spilt
	
	(berechnen()
	;(display "berechnen luft")
	(setf z-anzahl (- anzahl 1)) ; Anzahl der Zwischenrume
 	(setf u1 (gpnt2d_x Pkt1));; U-Koordinaten selectieren 
 	(setf v1 (gpnt2d_y Pkt1));; V-Koordinaten selectieren 
	(setf u2 (gpnt2d_x Pkt2));; U-Koordinaten selectieren 
 	(setf v2 (gpnt2d_y Pkt2));; V-Koordinaten selectieren 
 	(setf du (sqrt (expt (- u1 u2) 2)))
 	(setf dv (sqrt (expt (- v1 v2) 2)))
 	(setf winkel (sd-rad-to-deg (tan (/ dv du))))
	(setf g-laenge (sqrt (+ (expt du 2) (expt dv 2))))
	(setf stichmass (- g-laenge (* 2 rand) geo-mass))
	(setf zw-raum (- (/ stichmass z-anzahl) geo-mass))
	;   y = m x + b
	(setf m (/ dv du))
	(setf b (- v1 (* m u1)))	
	); end berechnen
	
	
	(punkte_setzen()
	
    (SD-CALL-CMDS (C_LINE_INF :TWO_POINTS Pkt1 Pkt2))
	
	;erster Punkt
	(setf u11 (+ u1 (* (/ (+ rand ) g-laenge) du)))
	(setf v11 (+ v1 (* (/ (+ rand ) g-laenge) dv)))
	(setf P11 (make-gpnt2d :x u11 :y v11))
    (SD-CALL-CMDS (C_LINE_INF :ANGLE P11 (sd-deg-to-rad (+ winkel 90))))
		(if (> geo-mass 0)
		(progn
		 (setf u12 (+ u1 (* (/ (+ rand geo-mass) g-laenge) du)))
		 (setf v12 (+ v1 (* (/ (+ rand geo-mass) g-laenge) dv)))
		 (setf P12 (make-gpnt2d :x u12 :y v12))
		 (SD-CALL-CMDS (C_LINE_INF :ANGLE P12 (sd-deg-to-rad (+ winkel 90))))
		))
	
	;zwischenpunkte
	(let ((counter 1))
	(loop
		(setf un1 (+ u1 (* (/ (+ rand geo-mass (* counter (+ geo-mass zw-raum))) g-laenge) du)))
		(setf vn1 (+ v1 (* (/ (+ rand geo-mass (* counter (+ geo-mass zw-raum))) g-laenge) dv)))
		(setf Pn1 (make-gpnt2d :x un1 :y vn1))
		(SD-CALL-CMDS (C_LINE_INF :ANGLE Pn1 (sd-deg-to-rad (+ winkel 90))))
			(if (> geo-mass 0)
			(progn
			(setf un2 (+ u1 (* (/ (+ rand (* counter (+ geo-mass zw-raum))) g-laenge) du)))
			(setf vn2 (+ v1 (* (/ (+ rand (* counter (+ geo-mass zw-raum))) g-laenge) dv)))
			(setf Pn2 (make-gpnt2d :x un2 :y vn2))
			(SD-CALL-CMDS (C_LINE_INF :ANGLE Pn2 (sd-deg-to-rad (+ winkel 90))))
			))
		
		(incf counter);; counter + 1
		(when (= counter anzahl)
			(return "done")
		); end when
	);end loop
	); end let
	
	); end punkte-setzen
  )


   :ok-action
   '(punkte_setzen)
   :cancel-action
   '()
   :cleanup-action
   '()
)

